package pmicrovenus;

import java.io.Serializable;
import javax.persistence.Entity;

@Entity
public class Estacion extends Casilla implements Serializable {
    
    //private String color;
    static public String GRUPO = "ESTACION";
    private float precioCompra;
    private float renta;
    
    public Estacion() {
    }
    
     public Estacion(int id, String des, int px, int py, float precio,float renta) {
        super(id,des,px,py); 
        this.precioCompra=precio;
        this.renta=renta;
        super.setValorHipoteca(precioCompra * 0.7f);
        
    }
     
   
    @Override
  public float getPrecioCompra() {
        return precioCompra;
    }

    public void setPrecioCompra(float val) {
        this.precioCompra = val;
    }

    @Override
    public float getRenta() {
        return renta; //renta * n estaciones + 1?
    }

    public void setRenta(float val) {
        this.renta = val;
    }

    @Override
    public void accion(Tablero t) {
       
        System.out.println(t.getJugadorActual().getNombre() + " ha caido en la casilla numero " + super.getNum() + ", " + super.getDescripcion());
        if (super.getPropietario()==null){
           System.out.println("Comprar estacion " + super.getDescripcion() + " por " + getPrecioCompra() + " ?"); 
           //Mostrar Dialogo Adquirir Pdad.
           jdlgAdquirirPdad dlg = new jdlgAdquirirPdad(t,t.formulario,true);
           dlg.setLocationRelativeTo(t.formulario);
           dlg.setVisible(true);
        }else{
            if (t.getJugadorActual().tieneEstacion(getDescripcion())){//si pertenece al jugador
                 
            }else{
                 if (this.isHipotecada()){
                    
                } else{//Si no Hipotecada
                     if(this.getPropietario().getNumEstaciones()>1){
                         float r = (getPropietario().getNumEstaciones()+1) * renta;
                         t.getJugadorActual().pagarRentaA(getPropietario(), r);
                     }else
                         t.getJugadorActual().pagarRentaA(getPropietario(),renta);
                }
                    
            }
        }
    
    }

}
