package pmicrovenus;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.swing.JOptionPane;

@Entity
public class Impuesto extends Casilla implements Serializable {
    private float precio;

    public Impuesto() {
        
    }
    
     public Impuesto(int id, String des, int px, int py, float precio) {
        super(id,des,px,py); 
        this.precio=precio;
    }

    @Override
    public void accion(Tablero t) {
        System.out.println(t.getJugadorActual().getNombre() + " ha caido en la casilla numero " + super.getNum() + ", " + super.getDescripcion());
        System.out.println("Pagar Impuesto por " + precio );
       
        String mens = "Pagar Impuesto por " + precio +" ";
        String tit = "Impuesto";
        JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
        
     //   new jdlgCasilla(new javax.swing.JFrame(), true,"impuesto.GIF").setVisible(true);
        
        t.getJugadorActual().reintegro(precio);
        
    }

    public float getPrecio() {
        return precio;
    }

    public void setPrecio(float val) {
        this.precio = val;
    }
}
