package pmicrovenus;


import java.io.Serializable;
import javax.persistence.Entity;
import javax.swing.JOptionPane;

@Entity
public class Salida extends Casilla implements Serializable {
    
    private float premio;
    
          
    public Salida() {          
    }
      
    public Salida(int id, String des, int px, int py, float premio) {
        super(id,des,px,py); 
        setPremio(premio);
    }

    @Override
     public void pasa(Jugador j) {
        System.out.println(j.getNombre() + " PASO POR LA SALIDA, COBRAS +" + getPremio());
        
        String mens = "PASO POR LA SALIDA, COBRAS " + getPremio() + " ";
        String tit = "PASO POR LA SALIDA";
        JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
         
       
//         new jdlgCasilla(new javax.swing.JFrame(), true,"salida.gif").setVisible(true);
        
        j.ingreso(getPremio());         
    }
       
    @Override
    public void accion(Tablero t) { 
        System.out.println(t.getJugadorActual().getNombre() + " ha caido en la casilla numero " + super.getNum() + ", " + super.getDescripcion());
        System.out.println("PASO POR LA SALIDA, COBRAS +" + getPremio());
        
//        new jdlgCasilla(new javax.swing.JFrame(), true,"salida.gif").setVisible(true);
        
        String mens = "PASO POR LA SALIDA, COBRAS " + getPremio() + " ";
        String tit = "SALIDA";
        JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
        
        
        t.getJugadorActual().ingreso(getPremio());
    }

    public float getPremio() {
        return premio;
    }

    public void setPremio(float premio) {
        this.premio = premio;
    }

}
